## libsecp256k1 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

#=============================
# Project / Package metadata
#=============================
project(libsecp256k1
  # The package (a.k.a. release) version is based on semantic versioning 2.0.0 of
  # the API. All changes in experimental modules are treated as
  # backwards-compatible and therefore at most increase the minor version.
  VERSION 0.6.0
  DESCRIPTION "Optimized C library for ECDSA signatures and secret/public key operations on curve secp256k1."
  HOMEPAGE_URL "https://github.com/bitcoin-core/secp256k1"
  LANGUAGES C
)
enable_testing()
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if(CMAKE_VERSION VERSION_LESS 3.21)
  # Emulates CMake 3.21+ behavior.
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(PROJECT_IS_TOP_LEVEL ON)
    set(${PROJECT_NAME}_IS_TOP_LEVEL ON)
  else()
    set(PROJECT_IS_TOP_LEVEL OFF)
    set(${PROJECT_NAME}_IS_TOP_LEVEL OFF)
  endif()
endif()

# The library version is based on libtool versioning of the ABI. The set of
# rules for updating the version can be found here:
# https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
# All changes in experimental modules are treated as if they don't affect the
# interface and therefore only increase the revision.
set(${PROJECT_NAME}_LIB_VERSION_CURRENT 5)
set(${PROJECT_NAME}_LIB_VERSION_REVISION 0)
set(${PROJECT_NAME}_LIB_VERSION_AGE 0)

#=============================
# Language setup
#=============================
set(CMAKE_C_STANDARD 90)
set(CMAKE_C_EXTENSIONS OFF)

#=============================
# Configurable options
#=============================
option(BUILD_SHARED_LIBS "Build shared libraries." ON)
option(SECP256K1_DISABLE_SHARED "Disable shared library. Overrides BUILD_SHARED_LIBS." OFF)
if(SECP256K1_DISABLE_SHARED)
  set(BUILD_SHARED_LIBS OFF)
endif()

option(SECP256K1_INSTALL "Enable installation." ${PROJECT_IS_TOP_LEVEL})

## Modules

# We declare all options before processing them, to make sure we can express
# dependendencies while processing.
option(SECP256K1_ENABLE_MODULE_ECDH "Enable ECDH module." ON)
option(SECP256K1_ENABLE_MODULE_RECOVERY "Enable ECDSA pubkey recovery module." OFF)
option(SECP256K1_ENABLE_MODULE_EXTRAKEYS "Enable extrakeys module." ON)
option(SECP256K1_ENABLE_MODULE_SCHNORRSIG "Enable schnorrsig module." ON)
option(SECP256K1_ENABLE_MODULE_MUSIG "Enable musig module." ON)
option(SECP256K1_ENABLE_MODULE_ELLSWIFT "Enable ElligatorSwift module." ON)

# Processing must be done in a topological sorting of the dependency graph
# (dependent module first).
if(SECP256K1_ENABLE_MODULE_ELLSWIFT)
  add_compile_definitions(ENABLE_MODULE_ELLSWIFT=1)
endif()

if(SECP256K1_ENABLE_MODULE_MUSIG)
  if(DEFINED SECP256K1_ENABLE_MODULE_SCHNORRSIG AND NOT SECP256K1_ENABLE_MODULE_SCHNORRSIG)
    message(FATAL_ERROR "Module dependency error: You have disabled the schnorrsig module explicitly, but it is required by the musig module.")
  endif()
  set(SECP256K1_ENABLE_MODULE_SCHNORRSIG ON)
  add_compile_definitions(ENABLE_MODULE_MUSIG=1)
endif()

if(SECP256K1_ENABLE_MODULE_SCHNORRSIG)
  if(DEFINED SECP256K1_ENABLE_MODULE_EXTRAKEYS AND NOT SECP256K1_ENABLE_MODULE_EXTRAKEYS)
    message(FATAL_ERROR "Module dependency error: You have disabled the extrakeys module explicitly, but it is required by the schnorrsig module.")
  endif()
  set(SECP256K1_ENABLE_MODULE_EXTRAKEYS ON)
  add_compile_definitions(ENABLE_MODULE_SCHNORRSIG=1)
endif()

if(SECP256K1_ENABLE_MODULE_EXTRAKEYS)
  add_compile_definitions(ENABLE_MODULE_EXTRAKEYS=1)
endif()

if(SECP256K1_ENABLE_MODULE_RECOVERY)
  add_compile_definitions(ENABLE_MODULE_RECOVERY=1)
endif()

if(SECP256K1_ENABLE_MODULE_ECDH)
  add_compile_definitions(ENABLE_MODULE_ECDH=1)
endif()

option(SECP256K1_USE_EXTERNAL_DEFAULT_CALLBACKS "Enable external default callback functions." OFF)
if(SECP256K1_USE_EXTERNAL_DEFAULT_CALLBACKS)
  add_compile_definitions(USE_EXTERNAL_DEFAULT_CALLBACKS=1)
endif()

set(SECP256K1_ECMULT_WINDOW_SIZE 15 CACHE STRING "Window size for ecmult precomputation for verification, specified as integer in range [2..24]. The default value is a reasonable setting for desktop machines (currently 15). [default=15]")
set_property(CACHE SECP256K1_ECMULT_WINDOW_SIZE PROPERTY STRINGS 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24)
include(CheckStringOptionValue)
check_string_option_value(SECP256K1_ECMULT_WINDOW_SIZE)
add_compile_definitions(ECMULT_WINDOW_SIZE=${SECP256K1_ECMULT_WINDOW_SIZE})

set(SECP256K1_ECMULT_GEN_KB 86 CACHE STRING "The size of the precomputed table for signing in multiples of 1024 bytes (on typical platforms). Larger values result in possibly better signing or key generation performance at the cost of a larger table. Valid choices are 2, 22, 86. The default value is a reasonable setting for desktop machines (currently 86). [default=86]")
set_property(CACHE SECP256K1_ECMULT_GEN_KB PROPERTY STRINGS 2 22 86)
check_string_option_value(SECP256K1_ECMULT_GEN_KB)
if(SECP256K1_ECMULT_GEN_KB EQUAL 2)
  add_compile_definitions(COMB_BLOCKS=2)
  add_compile_definitions(COMB_TEETH=5)
elseif(SECP256K1_ECMULT_GEN_KB EQUAL 22)
  add_compile_definitions(COMB_BLOCKS=11)
  add_compile_definitions(COMB_TEETH=6)
elseif(SECP256K1_ECMULT_GEN_KB EQUAL 86)
  add_compile_definitions(COMB_BLOCKS=43)
  add_compile_definitions(COMB_TEETH=6)
endif()

set(SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY "OFF" CACHE STRING "Test-only override of the (autodetected by the C code) \"widemul\" setting. Legal values are: \"OFF\", \"int128_struct\", \"int128\" or \"int64\". [default=OFF]")
set_property(CACHE SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY PROPERTY STRINGS "OFF" "int128_struct" "int128" "int64")
check_string_option_value(SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY)
if(SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY)
  string(TOUPPER "${SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY}" widemul_upper_value)
  add_compile_definitions(USE_FORCE_WIDEMUL_${widemul_upper_value}=1)
endif()
mark_as_advanced(FORCE SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY)

set(SECP256K1_ASM "AUTO" CACHE STRING "Assembly to use: \"AUTO\", \"OFF\", \"x86_64\" or \"arm32\" (experimental). [default=AUTO]")
set_property(CACHE SECP256K1_ASM PROPERTY STRINGS "AUTO" "OFF" "x86_64" "arm32")
check_string_option_value(SECP256K1_ASM)
if(SECP256K1_ASM STREQUAL "arm32")
  enable_language(ASM)
  include(CheckArm32Assembly)
  check_arm32_assembly()
  if(HAVE_ARM32_ASM)
    add_compile_definitions(USE_EXTERNAL_ASM=1)
  else()
    message(FATAL_ERROR "ARM32 assembly requested but not available.")
  endif()
elseif(SECP256K1_ASM)
  include(CheckX86_64Assembly)
  check_x86_64_assembly()
  if(HAVE_X86_64_ASM)
    set(SECP256K1_ASM "x86_64")
    add_compile_definitions(USE_ASM_X86_64=1)
  elseif(SECP256K1_ASM STREQUAL "AUTO")
    set(SECP256K1_ASM "OFF")
  else()
    message(FATAL_ERROR "x86_64 assembly requested but not available.")
  endif()
endif()

option(SECP256K1_EXPERIMENTAL "Allow experimental configuration options." OFF)
if(NOT SECP256K1_EXPERIMENTAL)
  if(SECP256K1_ASM STREQUAL "arm32")
    message(FATAL_ERROR "ARM32 assembly is experimental. Use -DSECP256K1_EXPERIMENTAL=ON to allow.")
  endif()
endif()

set(SECP256K1_VALGRIND "AUTO" CACHE STRING "Build with extra checks for running inside Valgrind. [default=AUTO]")
set_property(CACHE SECP256K1_VALGRIND PROPERTY STRINGS "AUTO" "OFF" "ON")
check_string_option_value(SECP256K1_VALGRIND)
if(SECP256K1_VALGRIND)
  find_package(Valgrind MODULE)
  if(Valgrind_FOUND)
    set(SECP256K1_VALGRIND ON)
    include_directories(${Valgrind_INCLUDE_DIR})
    add_compile_definitions(VALGRIND)
  elseif(SECP256K1_VALGRIND STREQUAL "AUTO")
    set(SECP256K1_VALGRIND OFF)
  else()
    message(FATAL_ERROR "Valgrind support requested but valgrind/memcheck.h header not available.")
  endif()
endif()

option(SECP256K1_BUILD_BENCHMARK "Build benchmarks." ON)
option(SECP256K1_BUILD_TESTS "Build tests." ON)
option(SECP256K1_BUILD_EXHAUSTIVE_TESTS "Build exhaustive tests." ON)
option(SECP256K1_BUILD_CTIME_TESTS "Build constant-time tests." ${SECP256K1_VALGRIND})
option(SECP256K1_BUILD_EXAMPLES "Build examples." OFF)

# Redefine configuration flags.
# We leave assertions on, because they are only used in the examples, and we want them always on there.
if(MSVC)
  string(REGEX REPLACE "/DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  string(REGEX REPLACE "/DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
  string(REGEX REPLACE "/DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL}")
else()
  string(REGEX REPLACE "-DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  string(REGEX REPLACE "-DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
  string(REGEX REPLACE "-DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL}")
  # Prefer -O2 optimization level. (-O3 is CMake's default for Release for many compilers.)
  string(REGEX REPLACE "-O3( |$)" "-O2\\1" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif()

# Define custom "Coverage" build type.
set(CMAKE_C_FLAGS_COVERAGE "${CMAKE_C_FLAGS_RELWITHDEBINFO} -O0 -DCOVERAGE=1 --coverage" CACHE STRING
  "Flags used by the C compiler during \"Coverage\" builds."
  FORCE
)
set(CMAKE_EXE_LINKER_FLAGS_COVERAGE "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} --coverage" CACHE STRING
  "Flags used for linking binaries during \"Coverage\" builds."
  FORCE
)
set(CMAKE_SHARED_LINKER_FLAGS_COVERAGE "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} --coverage" CACHE STRING
  "Flags used by the shared libraries linker during \"Coverage\" builds."
  FORCE
)
mark_as_advanced(
  CMAKE_C_FLAGS_COVERAGE
  CMAKE_EXE_LINKER_FLAGS_COVERAGE
  CMAKE_SHARED_LINKER_FLAGS_COVERAGE
)

if(PROJECT_IS_TOP_LEVEL)
  get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  set(default_build_type "RelWithDebInfo")
  if(is_multi_config)
    set(CMAKE_CONFIGURATION_TYPES "${default_build_type}" "Release" "Debug" "MinSizeRel" "Coverage" CACHE STRING
      "Supported configuration types."
      FORCE
    )
  else()
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY
      STRINGS "${default_build_type}" "Release" "Debug" "MinSizeRel" "Coverage"
    )
    if(NOT CMAKE_BUILD_TYPE)
      message(STATUS "Setting build type to \"${default_build_type}\" as none was specified")
      set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING
        "Choose the type of build."
        FORCE
      )
    endif()
  endif()
endif()

include(TryAppendCFlags)
if(MSVC)
  # Keep the following commands ordered lexicographically.
  try_append_c_flags(/W3) # Production quality warning level.
  try_append_c_flags(/wd4146) # Disable warning C4146 "unary minus operator applied to unsigned type, result still unsigned".
  try_append_c_flags(/wd4244) # Disable warning C4244 "'conversion' conversion from 'type1' to 'type2', possible loss of data".
  try_append_c_flags(/wd4267) # Disable warning C4267 "'var' : conversion from 'size_t' to 'type', possible loss of data".
  # Eliminate deprecation warnings for the older, less secure functions.
  add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
else()
  # Keep the following commands ordered lexicographically.
  try_append_c_flags(-pedantic)
  try_append_c_flags(-Wall) # GCC >= 2.95 and probably many other compilers.
  try_append_c_flags(-Wcast-align) # GCC >= 2.95.
  try_append_c_flags(-Wcast-align=strict) # GCC >= 8.0.
  try_append_c_flags(-Wconditional-uninitialized) # Clang >= 3.0 only.
  try_append_c_flags(-Wextra) # GCC >= 3.4, this is the newer name of -W, which we don't use because older GCCs will warn about unused functions.
  try_append_c_flags(-Wnested-externs)
  try_append_c_flags(-Wno-long-long) # GCC >= 3.0, -Wlong-long is implied by -pedantic.
  try_append_c_flags(-Wno-overlength-strings) # GCC >= 4.2, -Woverlength-strings is implied by -pedantic.

=== debian/changelog ===
libsecp256k1 (0.6.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Soren Stoutner <soren@debian.org>  Wed, 05 Nov 2025 12:09:05 -0700

libsecp256k1 (0.6.0-1) experimental; urgency=medium

  * New Upstream Release

  [ Manuel Guerra ]
  * New Maintainer Upload
  * Add file debian/salsa-ci.yml to manage Salsa's CI
  * Update file format and stanzas in copyright:
    - Set files: * stanza.
    - Format text to fit 80 columns.
    - Rewrite stanzas format for more comfortable lecture.
    - Add license paragraph for GPL-3+, CC0-1.0 and Apache-2.0.
  * Update debian/control file:
    - Update uploaders list to include new co-maintainers.
    - Bump Standards-Version to 4.7.2 (no changes required).
    - Reformat text file to fit 80 columns.
    - Change library package name to libsecp256k1-5.
  * Update debian/watch file to a simpler format.
  * Add debian/upstream/metadata file.
  * Update .symbols file:
    - Remove debian/libsecp256k1-2.symbols file.
    - Add new debian/libsecp256k1-5.symbols file.
  * Add debian/libsecp256k1-dev.install file to install examples
  * Remove obsolete debian/source/lintian-overrides.
  * Add hardening options in debian/rules.

  [ Soren Stoutner ]
  * Remove debian/upstream/signing-key.asc as upstream does not release signed
    tarballs.
  * debian/control:  Remove Jonas Smedegaard <dr@jones.dk> as an uploader
    according to his instructions.

 -- Manuel Guerra <ar.manuelguerra@gmail.com>  Sat, 09 Aug 2025 08:27:23 -0300

=== debian/control ===
Source: libsecp256k1
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkgconf,
               libgmp-dev,
               autoconf-archive,
               libssl-dev,
               d-shlibs,
               pkg-kde-tools
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders: Soren Stoutner <soren@debian.org>,
           Manuel Guerra <ar.manuelguerra@gmail.com>
Homepage: https://github.com/bitcoin/secp256k1
Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
Standards-Version: 4.7.2

Package: libsecp256k1-5
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: library for EC operations on curve secp256k1
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is intended to be the highest quality publicly available
 library for cryptography on the secp256k1 curve. However, the primary focus of
 its development has been for usage in the Bitcoin system and usage unlike
 Bitcoin's may be less well tested, verified, or suffer from a less well thought
 out interface. Correct usage requires some care and consideration that the
 library is fit for your application's purpose.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Additive and multiplicative tweaking of secret/public keys.
  * Serialization/parsing of secret keys, public keys, signatures.
  * Constant time, constant memory access signing and public key generation.
  * Derandomized ECDSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
  * Suitable for embedded systems.
  * Optional module for public key recovery.
  * Optional module for ECDH key exchange.

Package: libsecp256k1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsecp256k1-5 (= ${binary:Version}),
         pkgconf,
         ${devlibs:Depends},
         ${misc:Depends}
Description: library for EC operations on curve secp256k1 - development headers
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is intended to be the highest quality publicly available
 library for cryptography on the secp256k1 curve. However, the primary focus of
 its development has been for usage in the Bitcoin system and usage unlike
 Bitcoin's may be less well tested, verified, or suffer from a less well thought
 out interface. Correct usage requires some care and consideration that the
 library is fit for your application's purpose.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Additive and multiplicative tweaking of secret/public keys.
  * Serialization/parsing of secret keys, public keys, signatures.
  * Constant time, constant memory access signing and public key generation.
  * Derandomized ECDSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
  * Suitable for embedded systems.
  * Optional module for public key recovery.
  * Optional module for ECDH key exchange.
 .
 This package provides header files for developing your applications to use
 libbitcoin template engine.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,now

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-module-recovery \
		--enable-module-ecdh \
		--enable-module-extrakeys \
		--enable-module-schnorrsig

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
override_dh_install:
	dh_install
	d-shlibmove --commit \
		--devunversioned \
		--exclude-la \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so

=== debian/watch ===
version=4
https://github.com/bitcoin-core/secp256k1/tags .*/v?(\d.*)\.tar\.gz

## libsecp256k1 0.7.0

=== debian/changelog ===
libsecp256k1 (0.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Manuel Guerra <ar.manuelguerra@gmail.com>  Sat, 06 Dec 2025 18:59:35 +0000

libsecp256k1 (0.7.0-1) experimental; urgency=medium

  * New upstream release.

  [ Manuel Guerra ]
  * debian/watch: Bump to uscan version 5, rewrite source files.
  * debian/control: Update soname version.
  * debian/libsecp256k1-*.symbols: Update to soname version 6.
  * debian/copyright: Update stanzas.

  [ Soren Stoutner ]
  * Add debian/libsecp256k1-6.lintian-overrides to override a
    spelling-error-in-binary flase positive.

 -- Soren Stoutner <soren@debian.org>  Mon, 17 Nov 2025 18:14:06 -0700

=== debian/watch ===
Version: 5

Template: Github
Owner: bitcoin-core
Project: secp256k1

## libsecp256k1 0.7.1

=== debian/changelog ===
libsecp256k1 (0.7.1-1) experimental; urgency=medium

  * New upstream version.
  * Update control file: Bump standars version to 4.7.3, remove priority tag.
  * Update year of copyright holders for debian/* stanza in copyright file.
  * Update override libsecp256k1-6.lintian-overrides.
  * Add source lintian-overrides.

 -- Manuel Guerra <ar.manuelguerra@gmail.com>  Wed, 11 Feb 2026 18:59:35 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libsecp256k1
 Section: libs
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                pkgconf,
                libgmp-dev,
@@ -14,9 +13,9 @@
 Homepage: https://github.com/bitcoin/secp256k1
 Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
 Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 
-Package: libsecp256k1-5
+Package: libsecp256k1-6
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -47,7 +46,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libsecp256k1-5 (= ${binary:Version}),
+Depends: libsecp256k1-6 (= ${binary:Version}),
          pkgconf,
          ${devlibs:Depends},
          ${misc:Depends}
